/*
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this code; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  */

/* Copyright (C) 2002 Ian Zimmerman <itz@speakeasy.org> */

#ifndef INCLUDE_GIM_ABSTRACT_HANDLER_HH
#define INCLUDE_GIM_ABSTRACT_HANDLER_HH

/* $Id: gim_abstract_handler.hh,v 1.3 2002/08/26 19:24:59 itz Exp $ */

#ifdef __cplusplus

#include <libgim/gim_connection.hh>

extern "C" {
#include <libgim/gim_public.h>
}

class gim_abstract_handler {
public:
  gim_abstract_handler();
  virtual ~gim_abstract_handler();
  int event_select(gim_connection* conn);
  int was_fake();

private:
  struct gim_handler_data_t d;
  static int static_handler (struct gim_event_t*, struct gim_handler_data_t*);
  virtual int object_handler (struct gim_event_t*) = 0;
  virtual int char_source ();
  static int getcfun (void* p);

protected:
  gim_handler_data_t* get_data_p();
};

#endif // __cplusplus

#endif // INCLUDE_GIM_ABSTRACT_HANDLER_HH
